unit Demo3Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AHWord97,jwWord97,
  StdCtrls, ExtCtrls, OleCtnrs, Db, DBTables;

type
  TfrmDemo3 = class(TForm)
    btnInsert: TButton;
    btnOpenWord: TButton;
    btnCloseWord: TButton;
    btnOpenDoc: TButton;
    btnClose: TButton;
    Shape1: TShape;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnCloseDoc: TButton;
    mmoInfo: TMemo;
    Label5: TLabel;
    Database1: TDatabase;
    qryCustomer: TQuery;
    qryOrders: TQuery;
    srcCustomer: TDataSource;
    procedure btnOpenWordClick(Sender: TObject);
    procedure btnCloseWordClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure btnOpenDocClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseDocClick(Sender: TObject);
  private
    WrdApp : TWordApp;
    WrdDoc : TWordDoc;
    procedure WordAppQuit(Sender: TObject);
    procedure WordPreClose(Sender: TObject);
    procedure WordDocOpen(WordApp: TWordApp; WordDoc : TWordDoc);
    procedure WordDocChange(WordApp: TWordApp; WordDoc : TWordDoc);
    procedure WordDocClose(WordApp: TWordApp; WordDoc : TWordDoc);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo3: TfrmDemo3;

implementation

uses
  {$IFDEF VER130} {$IFDEF USE_WORD2K} Word2000; {$ELSE} Word97; {$ENDIF} {$ELSE} Word_TLB; {$ENDIF}

{$R *.DFM}

procedure TfrmDemo3.btnOpenWordClick(Sender: TObject);
begin
  WrdApp := TWordApp.Create (True, True);
  with WrdApp do
  begin
    OnQuit := WordAppQuit;
    OnChangeDocument := WordDocChange;
    OnOpenDocument := WordDocOpen;
    OnPreCloseDocument := WordPreClose;
    OnCloseDocument := WordDocClose;
    Visible := True;
    DisableSystemCloseBox;
  end;
  btnOpenDoc.Enabled := True;
  btnOpenDoc.SetFocus;
  btnCloseWord.Enabled := True;
  btnOpenWord.Enabled := False;
end;

procedure TfrmDemo3.btnOpenDocClick(Sender: TObject);
begin
  WrdDoc := TWordDoc.CreateOpenDoc (WrdApp, ExtractFilePath(Application.EXEName)
   + 'Test3.doc');
  btnInsert.Enabled := True;
  btnInsert.SetFocus;
  btnCloseDoc.Enabled := True;
  btnOpenDoc.Enabled := False;
end;

procedure TfrmDemo3.btnInsertClick(Sender: TObject);
begin
  ProcessBookmarks (WrdDoc, qryCustomer);
  ProcessTables (WrdDoc, qryOrders);
  ProcessTables2 (WrdDoc, qryOrders);
  btnCloseDoc.SetFocus;
end;

procedure TfrmDemo3.btnCloseDocClick(Sender: TObject);
begin
  if Assigned (wrdDoc) then
  begin
    WrdDoc.CloseDoc (wdDoNotSaveChanges);
    WrdDoc := nil;
  end;
  btnCloseDoc.Enabled := False;
  btnOpenDoc.Enabled := True;
  btnCloseWord.SetFocus;
end;

procedure TfrmDemo3.btnCloseWordClick(Sender: TObject);
begin
  if Assigned (WrdApp) then
  begin
    WrdApp.CloseApp (wdDoNotSaveChanges);
    WrdApp := nil;
  end;
  btnOpenWord.Enabled := True;
  btnOpenDoc.Enabled := False;
  btnCloseDoc.Enabled := False;
  btnInsert.Enabled := False;
  btnCloseWord.Enabled := False;
  btnClose.SetFocus;
end;

procedure TfrmDemo3.btnCloseClick(Sender: TObject);
begin
  Close
end;

procedure TfrmDemo3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned (WrdApp) then WrdApp.Free;
end;

procedure TfrmDemo3.WordAppQuit(Sender: TObject);
begin
  mmoInfo.Lines.Add ('WordAppQuit');
end;

procedure TfrmDemo3.WordPreClose(Sender: TObject);
begin
  // happens before the document has been closed so you can still
  // "get at it". Also, if the document is not "dirty" then Word will
  // display a "Do you want to save..." dialog. If the user presses cancel
  // then the document WILL NOT BE CLOSED
  mmoInfo.Lines.Add ('WordPreClose');
end;

procedure TfrmDemo3.WordDocChange(WordApp: TWordApp; WordDoc : TWordDoc);
begin
  mmoInfo.Lines.Add ('WordDocChange: ' + WordDoc.FullName);
end;

procedure TfrmDemo3.WordDocOpen(WordApp: TWordApp; WordDoc : TWordDoc);
begin
  mmoInfo.Lines.Add ('WordDocOpen: ' + WordDoc.FullName);
end;

procedure TfrmDemo3.WordDocClose(WordApp: TWordApp; WordDoc : TWordDoc);
begin
  // Note you cannot do anything with WordDoc that would involve
  // accessing the COM document as it has already gone - see WordPreClose
  mmoInfo.Lines.Add ('WordDocClose: ' + WordDoc.FullName);
end;

end.